/* mu_ask - get responses to menu items
 * Keeps looping over string and choice fields;
 * terminates when user selects an action field, or hits SCR_EXIT.
 */
#include "menu.h"
FIELD *mu_ask(pm)
	MENU *pm;		/* ptr to current MENU */
	{
	FIELD *pf;		/* ptr to current FIELD */
	FIELD *pfj;		/* ptr to j-th FIELD of this MENU */
	SCR_CMDCHAR c;	/* most recent user key input */
	char vtype;		/* value type of current FIELD */
	bool legal;		/* is  c  valid input in this state? */
	short j;		/* index over FIELDs of this MENU */

	pm->cur_field = 0;		/* start with first field */
	FOREVER
		{
		pf = &pm->fields[pm->cur_field];
		legal = YES;
		vtype = pf->val_type;

		/* accept user input, get user's SCR_CMDCHAR */
		if (vtype == 'c' || tolower(vtype) == 's')
			{
			if (vtype == 'c')
				c = mu_chv(pf);
			else			/* vtype == 's' OR 'S' */
				c = mu_str(pf);
			if (pf->pfn != NULL)
				legal = (*pf->pfn)(pm);
			if (c == SCR_EXIT)
				return (NULL);
			}
		else
			{
			scr_curs(pf->line, pf->col);
			c = scr_getkey();
			}
		/* at this point, c is the user's response, and */
		/* legal records validity of 'c' or 's' field */
		/* (more) */																/*
.PE
.PS  46
		/* determine next action, based on c */
		if (c == SCR_RETURN && (vtype == 'm' || vtype == 'f'))
			return (pf);
		else if (c == SCR_EXIT)
			return (NULL);
		else if (!legal)
			;		/* no actions allowed if validation failed */
		else if (vtype == 'S' && pf->psv->string[0] == '\0')
			legal = NO;
		else if (!SCR_CMD(c) && tolower(vtype) != 's')
			{
			legal = NO;	/* tentatively */
			for (j = 0; j < pm->nfields; ++j)
				{
				pfj = &pm->fields[j];
				if (toupper(pfj->desc[0]) == toupper(c))
					{
					pm->cur_field = j;
					legal = YES;
					break;
					}
				}
			}
		else if (SCR_CMD(c))
			{
			switch (c)
				{
			case SCR_UP:
				pm->cur_field = IMOD(pm->cur_field - 1, pm->nfields);
				break;
			case SCR_DOWN:
			case SCR_RETURN:
				pm->cur_field = IMOD(pm->cur_field + 1, pm->nfields);
				break;
			case SCR_HOME:
				pm->cur_field = 0;
				break;
			default:
				legal = NO;
				break;
				}
			}
		if (!legal)
			scr_beep();
		} /* end FOREVER */
	}
